package cz.frantovo.springDemo1.web;

import cz.frantovo.springDemo1.KnihaDAORemote;
import cz.frantovo.springDemo1.KnihaDAOjdbcRemote;
import cz.frantovo.springDemo1.dto.Kniha;
import java.util.Collection;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 *
 * @author fiki
 */
public class SpringDemo1Bean {

    private static final Logger log = Logger.getLogger(SpringDemo1Bean.class.getSimpleName());
    private KnihaDAORemote knihaDAO;
    private KnihaDAOjdbcRemote knihaDAOjdbc;

    /** Spring JdbcTemplate */
    public Collection<Kniha> getKnihy() {
	return lookupKnihaDAO().getKnihy();
    }

    /** JDBC */
    public Collection<Kniha> getKnihyJdbc() {
	return lookupKnihaDAOjdbc().getKnihy();
    }

    /** Spring JdbcTemplate */
    private KnihaDAORemote lookupKnihaDAO() {
        if (knihaDAO == null) {
            try {
                Context c = new InitialContext();
                knihaDAO = (KnihaDAORemote) c.lookup("cz.frantovo.springDemo1.KnihaDAORemote");
            } catch (NamingException e) {
                log.log(Level.SEVERE, "Chyba při hledání KnihaDAO", e);
                throw new RuntimeException(e);
            }
        }
        return knihaDAO;
    }

    /** JDBC */
    private KnihaDAOjdbcRemote lookupKnihaDAOjdbc() {
        if (knihaDAOjdbc == null) {
            try {
                Context c = new InitialContext();
                knihaDAOjdbc = (KnihaDAOjdbcRemote) c.lookup("cz.frantovo.springDemo1.KnihaDAOjdbcRemote");
            } catch (NamingException e) {
                log.log(Level.SEVERE, "Chyba při hledání KnihaDAOjdbc", e);
                throw new RuntimeException(e);
            }
        }
        return knihaDAOjdbc;
    }

}
